﻿using System;
using System.Windows.Forms;

namespace Dynamixel {

  public partial class UCServoPort : UserControl {

    EZ_B.Servo.ServoPortEnum _port;

    public UCServoPort() {

      InitializeComponent();

      cbEnabled_CheckedChanged(null, null);

      cbVersion.Items.Clear();
      foreach (FormMain.VersionEnum v in Enum.GetValues(typeof(FormMain.VersionEnum)))
        cbVersion.Items.Add(v);

      cbVersion.SelectedItem = FormMain.VersionEnum.Protocol_1;
    }

    public EZ_B.Servo.ServoPortEnum SetPort
    {
      get
      {
        return _port;
      }
      set
      {
        groupBox1.Text = value.ToString();
        _port = value;
      }
    }

    public bool SetEnabled
    {
      get
      {
        return cbEnabled.Checked;
      }
      set
      {
        cbEnabled.Checked = value;

        cbEnabled_CheckedChanged(null, null);
      }
    }

    public int SetMaxPosition
    {
      get
      {
        return Convert.ToInt32(tbMaxResolution.Text);
      }
      set
      {
        tbMaxResolution.Text = value.ToString();
      }
    }

    public FormMain.VersionEnum SetVersion
    {
      get
      {
        return (FormMain.VersionEnum)cbVersion.SelectedItem;
      }
      set
      {
        cbVersion.SelectedItem = value;
      }
    }

    private void cbEnabled_CheckedChanged(object sender, EventArgs e) {

      tbMaxResolution.Enabled = cbEnabled.Checked;
      cbVersion.Enabled = cbEnabled.Checked;
    }
  }
}
